Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;

----------------------------------------------------------------

entity Mux_4x16 is 
	port( 	
			clk			: in std_logic;
			nreset		: in std_logic;
			
			Sel_nA_B		: in std_logic;			
			
			A_1	: in std_logic_vector(15 downto 0);
			A_2	: in std_logic_vector(15 downto 0);
			A_3	: in std_logic_vector(15 downto 0);
			A_4	: in std_logic_vector(15 downto 0);

			B_1	: in std_logic_vector(15 downto 0);
			B_2	: in std_logic_vector(15 downto 0);
			B_3	: in std_logic_vector(15 downto 0);
			B_4	: in std_logic_vector(15 downto 0);
			
			Out_reg_1	: out std_logic_vector(15 downto 0);
			Out_reg_2	: out std_logic_vector(15 downto 0);
			Out_reg_3	: out std_logic_vector(15 downto 0);
			Out_reg_4	: out std_logic_vector(15 downto 0)
		);
	end Mux_4x16;
	
architecture main of Mux_4x16 is	

           
begin
	SYNCRONIZE_SAMPLE:
	process(clk, nreset, Sel_nA_B, A_1, A_2, A_3, A_4, B_1, B_2, B_3, B_4)
    begin
		if   (nreset = '0') then 
			Out_reg_1 <= (others => '0');
			Out_reg_2 <= (others => '0');
			Out_reg_3 <= (others => '0');
			Out_reg_4 <= (others => '0');
		
      elsif rising_edge(clk) then
			if   (Sel_nA_B = '0') then
				Out_reg_1 <= A_1;
				Out_reg_2 <= A_2;
				Out_reg_3 <= A_3;
				Out_reg_4 <= A_4;
			else
				Out_reg_1 <= B_1;
				Out_reg_2 <= B_2;
				Out_reg_3 <= B_3;
				Out_reg_4 <= B_4;
			end if;			
		end if;
    end process;
              
end;