Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 2, 2010

entity CURVE_1024_MEM_MUX is 
	port( 
			PARAMS		: in std_logic_vector(31 downto 0);
			CURVE_SM	: in std_logic_vector(31 downto 0);
			CURVE_1		: in std_logic_vector(31 downto 0);
			CURVE_2		: in std_logic_vector(31 downto 0);
			CURVE_3		: in std_logic_vector(31 downto 0);
			CURVE_4		: in std_logic_vector(31 downto 0);
			CURVE_5		: in std_logic_vector(31 downto 0);
			CURVE_6		: in std_logic_vector(31 downto 0);
			CURVE_7		: in std_logic_vector(31 downto 0);
			CURVE_8		: in std_logic_vector(31 downto 0);
			
			ADDR		: in std_logic_vector(16 downto 13);
			
			SM_OUT	: out std_logic_vector(31 downto 0)
			
			
		);
	end CURVE_1024_MEM_MUX;
	
architecture main of CURVE_1024_MEM_MUX is	
begin
	process (ADDR, PARAMS, CURVE_SM, CURVE_1, CURVE_2, CURVE_3,
			 CURVE_4, CURVE_5, CURVE_6, CURVE_7, CURVE_8)
	begin
		case ADDR is
			when X"0" => SM_OUT <= PARAMS;
			when X"1" => SM_OUT <= CURVE_SM;
			when X"2" => SM_OUT <= CURVE_1;
			when X"3" => SM_OUT <= CURVE_2;
			when X"4" => SM_OUT <= CURVE_3;
			when X"5" => SM_OUT <= CURVE_4;
			when X"6" => SM_OUT <= CURVE_5;
			when X"7" => SM_OUT <= CURVE_6;
			when X"8" => SM_OUT <= CURVE_7;
			when X"9" => SM_OUT <= CURVE_8;
						              
			when others => SM_OUT <= X"BAD04444";
		end case;
	end process;
end;