Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 2, 2010

entity CURVE_MEM_MUX5a is 
	port( 
			CURVE_0		: in std_logic_vector(15 downto 0);
			CURVE_1		: in std_logic_vector(15 downto 0);
			CURVE_2		: in std_logic_vector(15 downto 0);
			CURVE_3		: in std_logic_vector(15 downto 0);
			CURVE_4		: in std_logic_vector(15 downto 0);
			
			ADDR		: in std_logic_vector(15 downto 12);
			
			CURVE_OUT	: out std_logic_vector(15 downto 0)
			
			
		);
	end CURVE_MEM_MUX5a;
	
architecture main of CURVE_MEM_MUX5a is	
begin
	process (ADDR, CURVE_0, CURVE_1, CURVE_2, CURVE_3, CURVE_4)
	begin
		case ADDR is
			when X"5" => CURVE_OUT <= CURVE_0;
			when X"6" => CURVE_OUT <= CURVE_1;
			when X"7" => CURVE_OUT <= CURVE_2;
			when X"8" => CURVE_OUT <= CURVE_3;
			when X"9" => CURVE_OUT <= CURVE_4;
						              
			when others => CURVE_OUT <= X"0000";
		end case;
	end process;
end;