Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;

----------------------------------------------------------------
entity FLASH_WRITE_COUNTER is 
	port( 	
			clk				: in std_logic;
			nreset			: in std_logic;
			Data_In			: in std_logic_vector(31 downto 0);
			Load_Count		: in std_logic;
			Backup_Trig		: in std_logic;
			
			Flash_Count_Out: out std_logic_vector(31 downto 0)
		);
	end FLASH_WRITE_COUNTER;
	
architecture main of FLASH_WRITE_COUNTER is	

signal count 	 	: std_logic_vector(31 downto 0);
signal inc_cnt 	: std_logic;
signal load_cnt	: std_logic;


--------------------------------------------------------------
begin
--------------------------------------------------------------

SYNC_CNT: led 
port map(	sig_in  => Backup_Trig, clk => clk, clrn => '1', pls_out => inc_cnt); 

SYNC_LOAD: led 
port map(	sig_in  => Load_Count, clk => clk, clrn => '1', pls_out => load_cnt); 
--------------------------------------------------------------

	FLASH_WRITE_COUNTER_PROC: 
	process(clk, nreset, load_cnt, inc_cnt, Data_In, count)
	begin	
		if rising_edge(clk) then
			if (nreset = '0') then 			count	<= (others => '0');
			elsif( load_cnt = '1') then 	count <= Data_In;
			elsif( inc_cnt = '1') then 	count <= count + 1;
			end if;                                            
		end if;
	end process;
 
	Flash_Count_Out <= count;
end;