Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE work.pkg_081006.all;  

-------------------------------------------------------------------- 

entity LIGHT_LED is
	port(clk      : in std_logic;
		 pulse_in : in std_logic;
		 led_out  : out std_logic
		);
end LIGHT_LED;
	
architecture main of LIGHT_LED is
	
	signal reset			: std_logic;
	signal count 			: std_logic_vector(27 downto 0);

begin -- main --------------------------------------------------------
	
LEADING_EDGE_DETECTOR: led 
port map(	sig_in  => pulse_in, 
			clk     => clk, 
			clrn    => '1', 
			pls_out => reset);
			 		
	process(clk, reset, count)
	begin
		if (reset = '1') then 
			count <= (others => '0');
			led_out	<= '1';
		elsif rising_edge(clk) then
			if   (count < X"2faf080") then 
				count 	<= count + 1;
				led_out	<= '1';
			else
				count 	<= count;
				led_out	<= '0';
			end if;
		end if;
	end process;
end main;

