Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 2, 2010

-- Version 2 added DATA_RUN and WR_RUN signals that can write data to the Lower
--  FPGA during the RUN phase.  April 13, 2016

entity Mem_Ctrl_Mux_x5_v2 is 
	port( 
			DATA_RUN		: in std_logic_vector(31 downto 0);
			ADDR_RUN		: in std_logic_vector(23 downto 0);
			WR_RUN		: in std_logic;
			RD_RUN		: in std_logic;
			ENA_RUN		: in std_logic;
			
			DATA_A		: in std_logic_vector(31 downto 0);
			ADDR_A		: in std_logic_vector(23 downto 0);
			WR_A			: in std_logic;
			RD_A			: in std_logic;
			ENA_A			: in std_logic;
			
			DATA_B		: in std_logic_vector(31 downto 0);
			ADDR_B		: in std_logic_vector(23 downto 0);
			WR_B			: in std_logic;
			RD_B			: in std_logic;
			ENA_B			: in std_logic;
			
			DATA_C		: in std_logic_vector(31 downto 0);
			ADDR_C		: in std_logic_vector(23 downto 0);
			WR_C			: in std_logic;
			RD_C			: in std_logic;
			ENA_C			: in std_logic;
			
			DATA_D		: in std_logic_vector(31 downto 0);
			ADDR_D		: in std_logic_vector(23 downto 0);
			WR_D			: in std_logic;
			RD_D			: in std_logic;
			ENA_D			: in std_logic;
			
			DATA_E		: in std_logic_vector(31 downto 0);
			ADDR_E		: in std_logic_vector(23 downto 0);
			WR_E			: in std_logic;
			RD_E			: in std_logic;
			ENA_E			: in std_logic;
			
			DATA		: out std_logic_vector(31 downto 0);
			ADDR		: out std_logic_vector(23 downto 0);
			WR			: out std_logic;
			RD			: out std_logic
		);
	end Mem_Ctrl_Mux_x5_v2;
	
architecture main of Mem_Ctrl_Mux_x5_v2  is	
begin
	
process ( 
		  ENA_RUN, DATA_RUN, ADDR_RUN, WR_RUN, RD_RUN,
		  ENA_A, DATA_A, ADDR_A, WR_A, RD_A, 
		  ENA_B, DATA_B, ADDR_B, WR_B, RD_B,
		  ENA_C, DATA_C, ADDR_C, WR_C, RD_C,
		  ENA_D, DATA_D, ADDR_D, WR_D, RD_D,
		  ENA_E, DATA_E, ADDR_E, WR_E, RD_E )
begin
	if    (ENA_RUN = '1') then
		DATA <= DATA_RUN; ADDR <= ADDR_RUN; WR <= WR_RUN; RD <= RD_RUN;

	elsif (ENA_A = '1') then 
		DATA <= DATA_A; ADDR <= ADDR_A; WR <= WR_A; RD <= RD_A;
				 		
	elsif (ENA_B = '1') then  
		DATA <= DATA_B; ADDR <= ADDR_B; WR <= WR_B; RD <= RD_B;
				
	elsif (ENA_C = '1') then  
		DATA <= DATA_C; ADDR <= ADDR_C; WR <= WR_C; RD <= RD_C;
	
	elsif (ENA_D = '1') then  
		DATA <= DATA_D; ADDR <= ADDR_D; WR <= WR_D; RD <= RD_D;
	
	elsif (ENA_E = '1') then  
		DATA <= DATA_E; ADDR <= ADDR_E; WR <= WR_E; RD <= RD_E;
	
	else
		DATA 	<= (others => '1'); 
		ADDR 	<= (others => '0'); 
		WR 		<= '0'; 
		RD 		<= '0';
				
	end if;
	                                          
end process;
end;