Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 2, 2010

entity WR_Addr_Decoder is 
	port( 
			WR_mem		: in std_logic;			
			ADDR		: in std_logic_vector(16 downto 12);
			ROM_override : in std_logic;
			
			WR_params	: out std_logic;
			WR_curve_sm	: out std_logic;
			WR_curve_1	: out std_logic;
			WR_curve_2	: out std_logic;
			WR_curve_3	: out std_logic;
			WR_curve_4	: out std_logic;
			WR_curve_5	: out std_logic;
			WR_curve_6	: out std_logic;
			WR_curve_7	: out std_logic;
			WR_curve_8	: out std_logic
			        
		);
	end WR_Addr_Decoder;
	
architecture main of WR_Addr_Decoder is	

signal WR : std_logic;
signal WR_rom : std_logic;

begin
	
	WR <= WR_mem;
	WR_rom <= ROM_override and WR;
	
	process (ADDR, WR, WR_rom)
	begin
			WR_params	<= '0';
			WR_curve_sm	<= '0';
			WR_curve_1	<= '0';
			WR_curve_2	<= '0';
			WR_curve_3	<= '0';
			WR_curve_4	<= '0';
			WR_curve_5	<= '0';
			WR_curve_6	<= '0';
			WR_curve_7	<= '0';
			WR_curve_8	<= '0';

		case ADDR(16 downto 12) is
			when "00000" => WR_params	 <= WR_rom; -- ROM 0x00000 to 0x00FFF
			when "00001" => WR_params	 <= WR; -- 0x01000 to 0x01FFF
			when "00010" => WR_curve_sm  <= WR;	-- 0x02000 to 0x03FFF
			when "00011" => WR_curve_sm  <= WR;	-- 0x02000 to 0x03FFF
			when "00100" => WR_curve_1	 <= WR;	-- 0x04000 to 0x05FFF
			when "00101" => WR_curve_1	 <= WR;	-- 0x04000 to 0x05FFF
			when "00110" => WR_curve_2	 <= WR;	-- 0x06000 to 0x07FFF
			when "00111" => WR_curve_2	 <= WR;	-- 0x06000 to 0x07FFF
			when "01000" => WR_curve_3	 <= WR;	-- 0x08000 to 0x09FFF
			when "01001" => WR_curve_3	 <= WR;	-- 0x08000 to 0x09FFF
			when "01010" => WR_curve_4	 <= WR;	-- 0x0A000 to 0x0BFFF
			when "01011" => WR_curve_4	 <= WR;	-- 0x0A000 to 0x0BFFF
			when "01100" => WR_curve_5	 <= WR;	-- 0x0C000 to 0x0DFFF
			when "01101" => WR_curve_5	 <= WR;	-- 0x0C000 to 0x0DFFF
			when "01110" => WR_curve_6	 <= WR;	-- 0x0E000 to 0x0FFFF
			when "01111" => WR_curve_6	 <= WR;	-- 0x0E000 to 0x0FFFF
			when "10000" => WR_curve_7	 <= WR;	-- 0x10000 to 0x11FFF
			when "10001" => WR_curve_7	 <= WR;	-- 0x10000 to 0x11FFF
			when "10010" => WR_curve_8	 <= WR; -- 0x12000 to 0x13FFF
			when "10011" => WR_curve_8	 <= WR; -- 0x12000 to 0x13FFF
			when others => NULL;		              
		end case;
	end process;
end;